#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_CumulativeSigninCFG.h"
std::auto_ptr<M_CumulativeSigninCFG> M_CumulativeSigninCFG::msSingleton(nullptr);

int M_CumulativeSigninCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_CumulativeSigninCFGData* M_CumulativeSigninCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_CumulativeSigninCFGData>& M_CumulativeSigninCFG::GetMapData()
{
	return mMapData;
}

void M_CumulativeSigninCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_CumulativeSigninCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_CumulativeSigninCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		{
			const char* Display = element->Attribute("Display");
			std::vector<std::string> vecDisplay;
			boost::split(vecDisplay, Display, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecDisplay.size(); i++)
			{
				data.mDisplay.push_back(vecDisplay[i]);
			}
		}
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		{
			const char* ItemCount = element->Attribute("ItemCount");
			std::vector<std::string> vecItemCount;
			boost::split(vecItemCount, ItemCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemCount[i].c_str(), &temp))
				{
					data.mItemCount.push_back(temp);
				}
			}
		}
		{
			const char* FloatingReward = element->Attribute("FloatingReward");
			std::vector<std::string> vecFloatingReward;
			boost::split(vecFloatingReward, FloatingReward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFloatingReward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFloatingReward[i].c_str(), &temp))
				{
					data.mFloatingReward.push_back(temp);
				}
			}
		}
		data.mNeedday = element->IntAttribute("Needday");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_CumulativeSigninCFG Loaded. Load Data:%u", mMapData.size());
}

void M_CumulativeSigninCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_CumulativeSigninCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_CumulativeSigninCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_CumulativeSigninCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readVectorString(L, "Display", data.mDisplay);
		LuaCfgHelper::readVectorInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readVectorInt(L, "ItemCount", data.mItemCount);
		LuaCfgHelper::readVectorInt(L, "FloatingReward", data.mFloatingReward);
		LuaCfgHelper::readInt(L, "Needday", data.mNeedday);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_CumulativeSigninCFG Loaded. Load Data:%u", mMapData.size());
}

void M_CumulativeSigninCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_CumulativeSigninCFG* M_CumulativeSigninCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_CumulativeSigninCFG());
	}
	return msSingleton.get();
}

void M_CumulativeSigninCFG::Release()
{
	msSingleton.reset(nullptr);
}
